<?php
class plgHikashoppaymentWesternunion extends JPlugin
{

    function onPaymentDisplay(&$order,&$methods,&$usable_methods){
    	if(!empty($methods)){
    		foreach($methods as $method){
				if($method->payment_type!='westernunion'){
					continue;
				}
				//remove the COD method if a zone is set for it and that the address of the user is not in that zone
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop::get('class.zone');
	    			$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}
				
				//if we don't want to use the built-in payment method description view, we can generate our own
				
				
				$usable_methods[$method->ordering]=$method;
    		}
    	}
    	return true;
    }
    
    function onPaymentSave(&$cart,&$rates,&$payment_id){
    	$usable = array();
    	$this->onPaymentDisplay($cart,$rates,$usable); 
    	$payment_id = (int) $payment_id;
    	// check that the shipping selected can be used
    	foreach($usable as $usable_method){
    		if($usable_method->payment_id==$payment_id){
    			return $usable_method;
    		}
    	}
    	
    	return false;
    }
    
    function onPaymentConfiguration(&$element){
    	$this->westernunion = JRequest::getCmd('name','westernunion');    	
    	if(empty($element)){
    		$element = null;
    		$element->payment_name='Western Union';
    		$element->payment_description='You can pay by Western Union.';
    		$element->payment_images='';
    		$element->payment_type=$this->banktransfer;
    		$element->payment_params=null;
    		$element->payment_params->information='';
    		$element->payment_params->order_status='created';
    		$element = array($element);
    	}
    	$bar = & JToolBar::getInstance('toolbar');
		JToolBarHelper::save();
		JToolBarHelper::apply();
		JToolBarHelper::cancel();
		JToolBarHelper::divider();
		$bar->appendButton( 'Pophelp','payment-westernunion-form');
		hikashop::setTitle(JText::_('Western Union'),'plugin','plugins&plugin_type=payment&task=edit&name='.$this->westernunion);
		$app =& JFactory::getApplication();
		$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->westernunion);
		$this->category = hikashop::get('type.categorysub');
		$this->category->type = 'status';
		$this->editor = hikashop::get('helper.editor');
    }
    
    function onPaymentConfigurationSave(&$element){
    	$element->payment_params->information = JRequest::getVar('bank_account_information','','','string',JREQUEST_ALLOWRAW);
    	return true;
    }
    
    function onAfterOrderConfirm(&$order,&$methods,$method_id){
    	$method =& $methods[$method_id];
    	$orderObj = null;
    	$orderObj->order_status = $method->payment_params->order_status;
    	$orderObj->order_id = $order->order_id;
    	$orderClass = hikashop::get('class.order');
    	$orderClass->save($orderObj);
    	$app =& JFactory::getApplication();

		$name = $method->payment_type.'_end.php';
    	$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
    	if(!file_exists($path)){
    		if(version_compare(JVERSION,'1.6','<')){
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
    		}else{
    			$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
    		}
    		if(!file_exists($path)){
    			//that should not happen !
    			return true;
    		}
    	}
    	$information = $method->payment_params->information;
    	if(preg_match('#^[a-z0-9_]*$#i',$information)){
    		$information = JText::_($information);
    	}
    	$currencyClass = hikashop::get('class.currency');
    	$amount = $currencyClass->format($order->order_full_price,$order->order_currency_id);
    	$order_number = hikashop::encode($order);
    	require($path);
    	
		return true;
    }
}